agreement/agreement/views/calculator.py
import http.client
import json
import math
import typing

import flask
import werkzeug.exceptions

from .. import database


calculator_blueprint = flask.Blueprint(
	"calculator",
	__name__
)

def get_closest_candidates(
	answers: typing.Dict[str, int],
	district: typing.Union[None, str] = None
) -> typing.Dict:
	resulting_candidates = {}
	max_points = 0

	for candidate_slug, candidate in flask.current_app.config["PEOPLE"].items():
		if (
			district is not None
			and candidate["district"] != district
		):
			continue
		
		resulting_candidates[candidate_slug] = {
			"points": 0,
			"percentage": 0
		}

	for question_slug, user_response in answers.items():
		for candidate, response in (
			flask.current_app.config
			["QUESTIONS"]
			[question_slug]
			["responses"]
		).items():
			if candidate not in resulting_candidates:
				continue
			
			resulting_candidates[candidate]["points"] += 1 - abs(response - user_response)

		max_points += 1

	for candidate in resulting_candidates:
		resulting_candidates[candidate]["percentage"] = math.floor(
			resulting_candidates[candidate]["points"]
			/ max_points
			* 100
		)

	with open("cached_results.json") as cached_results_file:
		cached_results = json.load(cached_results_file)

	resulting_candidates = dict(
		sorted(
			resulting_candidates.items(),
			key=lambda candidate: candidate[1]["points"],
			reverse=True
		)
	)

	return resulting_candidates


@calculator_blueprint.route("/", methods=["GET"])
def view_index() -> typing.Tuple[flask.Response, int]:
	return flask.render_template("index.html"), http.client.OK


@calculator_blueprint.route("/vysledek", methods=["GET", "POST"])
@flask.current_app.limiter.limit(
	"10/day",
	exempt_when=lambda: flask.request.method != "POST"
)
def view_result() -> typing.Tuple[flask.Response, int]:
	if flask.request.method == "GET":
		selected_district = None
		selected_district_slug = None

		if "obec" in flask.request.args:
			if (
				flask.request.args["obec"]
				not in flask.current_app.config["DISTRICTS"]
				and flask.request.args["obec"] != "zadna"
			):
				raise werkzeug.exceptions.BadRequest
			elif flask.request.args["obec"] != "zadna":
				selected_district = (
					flask.current_app.config
					["DISTRICTS"]
					[flask.request.args["obec"]]
				)
				selected_district_slug = flask.request.args["obec"]

		if "answers" not in flask.request.cookies:
			raise werkzeug.exceptions.BadRequest

		try:
			decoded_cookie = json.loads(flask.request.cookies["answers"])
		except json.JSONDecodeError:
			raise werkzeug.exceptions.BadRequest

		## Input validation
		if (
			"percentage" not in decoded_cookie
			or not isinstance(decoded_cookie["percentage"], int)
			or decoded_cookie["percentage"] < 0
			or decoded_cookie["percentage"] > 100
			or "answers" not in decoded_cookie
			or not isinstance(decoded_cookie["answers"], dict)
		):
			raise werkzeug.exceptions.BadRequest

		possible_answers = list(flask.current_app.config["QUESTIONS"])

		for answer_slug, answer_value in decoded_cookie["answers"].items():
			if (
				answer_slug not in possible_answers
				or not isinstance(answer_value, (float, int))
				or answer_value not in (
					flask.current_app.config["POINTS"]["neg-full"],
					flask.current_app.config["POINTS"]["neg-half"],
					flask.current_app.config["POINTS"]["neut"],
					flask.current_app.config["POINTS"]["pos-half"],
					flask.current_app.config["POINTS"]["pos-full"]
				)
			):
				raise werkzeug.exceptions.BadRequest

			possible_answers.remove(answer_slug)

		if len(possible_answers) != 0:
			possible_answers.remove(answer_slug)

		return flask.render_template(
			"result.html",
			percentage=math.floor(decoded_cookie["percentage"]),
			selected_district=selected_district,
			selected_district_slug=selected_district_slug,
			closest_candidates=get_closest_candidates(
				decoded_cookie["answers"],
				district=selected_district_slug
			)
		), http.client.OK
	else:
		answer_models = []

		with open("cached_results.json") as cached_results_file:
			cached_results = json.load(cached_results_file)

		max_points = cached_results["max"]
		user_points = 0
		user_answers = {}
		
		for question_slug, question in flask.current_app.config["QUESTIONS"].items():
			has_answer = False

			for form_input, point_value in {
				f"{question_slug}-neg-full": flask.current_app.config["POINTS"]["neg-full"],
				f"{question_slug}-neg-half": flask.current_app.config["POINTS"]["neg-half"],
				f"{question_slug}-neut": flask.current_app.config["POINTS"]["neut"],
				f"{question_slug}-pos-half": flask.current_app.config["POINTS"]["pos-half"],
				f"{question_slug}-pos-full": flask.current_app.config["POINTS"]["pos-full"]
			}.items():
				if flask.request.form.get(form_input) == "on":
					has_answer = True

					user_answers[question_slug] = point_value
					user_points += point_value

					answer_models.append(
						database.Answer(
							slug=question_slug,
							value=point_value
						)
					)

			if not has_answer:
				raise werkzeug.exceptions.BadRequest

		user_percentage = user_points / max_points * 100
		
		flask.g.sa_session.add_all(answer_models)

		response = flask.make_response(
			flask.render_template(
				"result.html",
				percentage=math.floor(user_percentage),
				selected_district=None,
				selected_district_slug=None,
				closest_candidates=get_closest_candidates(user_answers)
			)
		)

		response.set_cookie(
			"answers",
			json.dumps({
				"answers": user_answers,
				"percentage": math.floor(user_percentage)
			})
		)

		return response, http.client.OK


@calculator_blueprint.route("/kandidati", methods=["GET"])
def view_candidates_responses() -> typing.Tuple[flask.Response, int]:
	selected_district = None
	selected_district_slug = None
	cached_results = None

	if "obec" in flask.request.args:
		if (
			flask.request.args["obec"]
			not in flask.current_app.config["DISTRICTS"]
			and flask.request.args["obec"] != "zadna"
		):
			raise werkzeug.exceptions.BadRequest
		elif flask.request.args["obec"] != "zadna":
			selected_district = (
				flask.current_app.config
				["DISTRICTS"]
				[flask.request.args["obec"]]
			)
			selected_district_slug = flask.request.args["obec"]

			with open("cached_results.json", "r") as cached_results_file:
				cached_results = json.load(cached_results_file)

	return flask.render_template(
		"candidates_responses.html",
		selected_district=selected_district,
		selected_district_slug=selected_district_slug,
		cached_results=cached_results
	), http.client.OK


@calculator_blueprint.route("/kandidati/<string:person_slug>")
def view_candidate_opinions(
	person_slug: str
) -> typing.Tuple[flask.Response, int]:
	if person_slug not in flask.current_app.config["PEOPLE"]:
		raise werkzeug.exceptions.NotFound

	with open("cached_results.json", "r") as cached_results_file:
		return flask.render_template(
			"candidate_opinions.html",
			person_slug=person_slug,
			cached_results=json.load(cached_results_file)
		)

agreement/agreement/templates/base.html
<!DOCTYPE html>
<html lang="cs">
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1">
		
		<link
			rel="stylesheet"
			type="text/css"
			href="{{ url_for('static', filename='css/base.css') }}"
		>
		<link
			rel="icon"
			type="image/png"
			href="{{ url_for('static', filename='images/icon.png') }}"
		>
		<script
			src="{{ url_for('static', filename='js/jquery.js') }}"
			type="text/javascript"
		></script>
		
		<meta name="author" content="Piráti">
		<meta
			name="description"
			content="{% block description %}{% endblock %}"
		>
		
		<meta
			property="og:title"
			content="{% block current_page %}{% endblock %}"
		>
		<meta
			property="og:image"
			content="http://localhost/static/images/icon.png"
		> <!-- (FIXME) -->
		<meta
			property="og:description"
			content="{{ self.description() }}"
		>
		
		{% block head %}{% endblock %}
		
		<title>{{ self.current_page() }}</title>
	</head>
	<body>
		{% block content %}{% endblock %}
	</body>
</html>

agreement/agreement/templates/candidate_opinions.html
{% extends 'base.html' %}
{% set person = config["PEOPLE"][person_slug] %}

{% block head %}
	<link
		rel="stylesheet"
		type="text/css"
		href="{{ url_for('static', filename='css/candidate_opinions.css') }}"
	>
	<link
		rel="stylesheet"
		type="text/css"
		href="{{ url_for('static', filename='css/select2.css') }}"
	>
	
	<link
		rel="stylesheet"
		type="text/css"
		href="{{ url_for('static', filename='fonts/open-sans/style.css') }}"
	>
	<link
		rel="stylesheet"
		type="text/css"
		href="{{ url_for('static', filename='fonts/bebas-neue/style.css') }}"
	>
{% endblock %}

{% block current_page %}Odpovědi - {{ person["name"] }}{% endblock %}

{% block description %}Shoda kandidáta {{ person["name"] }} s naším programem.{% endblock %}

{% block content %}
	<header>
		<h1>Odpovědi - {{ person["name"] }}</h1>
	</header>
	
	<main>
		<section class="person">
			<div class="person-image">
				<img
					src="{{ url_for('static', filename='images/people/' + person_slug + '.png') }}"
					alt="Fotka osoby {{ person["name"] }}"
				>
				
				<div class="person-agreement-percentage">
					<div
						class="person-agreement-percentage-bar"
						style="width:{{ cached_results["people"][person_slug]["percentage"] }}%;animation-delay:-{{ cached_results["people"][person_slug]["percentage"] / 100 }}s"
					>
						<span
							class="person-agreement-percentage-number"
						>Shoda {{ cached_results["people"][person_slug]["percentage"] }}%</span>
					</div>
				</div>
			</div>
			
			<div class="person-description">
				<h2>{{ person["name"] }}</h2>
				
				<tt style="background:grey;color:white;padding:5px">Sem patří popis kandidáta, odkazy, atd.</tt>
			</div>
		</section>
		
		<div class="questions">
			{% for slug, question in config["QUESTIONS"].items() %}
				{% set answer = question["responses"][person_slug] %}
				
				<h2>{{ question["content"] }}</h2>
				
				<div class="question-answers">
					<div class="question-answer question-answer-pos-full">
						<input
							type="checkbox"
							id="{{ slug }}-pos-full"
							name="{{ slug }}-pos-full"
							autocomplete="off"
							disabled
							{% if answer == config["POINTS"]["pos-full"] %}checked{% endif %}
						>
						
						<label
							id="{{ slug }}-pos-full-label"
							for="{{ slug }}-pos-full"
						></label>
					</div>
					
					<div class="question-answer question-answer-pos-half">
						<input
							type="checkbox"
							id="{{ slug }}-pos-half"
							name="{{ slug }}-pos-half"
							autocomplete="off"
							disabled
							{% if answer == config["POINTS"]["pos-half"] %}checked{% endif %}
						>
						
						<label
							id="{{ slug }}-pos-half-label"
							for="{{ slug }}-pos-half"
						></label>
					</div>
					
					<div class="question-answer question-answer-neut">
						<input
							type="checkbox"
							id="{{ slug }}-neut"
							name="{{ slug }}-neut"
							autocomplete="off"
							disabled
							{% if answer == config["POINTS"]["neut"] %}checked{% endif %}
						>
						
						<label
							id="{{ slug }}-neut-label"
							for="{{ slug }}-neut"
						></label>
					</div>
					
					<div class="question-answer question-answer-neg-half">
						<input
							type="checkbox"
							id="{{ slug }}-neg-half"
							name="{{ slug }}-neg-half"
							autocomplete="off"
							disabled
							{% if answer == config["POINTS"]["neg-half"] %}checked{% endif %}
						>
						
						<label
							id="{{ slug }}-neg-half-label"
							for="{{ slug }}-neg-half"
						></label>
					</div>
					
					<div class="question-answer question-answer-neg-full">
						<input
							type="checkbox"
							id="{{ slug }}-neg-full"
							name="{{ slug }}-neg-full"
							autocomplete="off"
							disabled
							{% if answer == config["POINTS"]["neg-full"] %}checked{% endif %}
						>
						
						<label
							id="{{ slug }}-neg-full-label"
							for="{{ slug }}-neg-full"
						></label>
					</div>
				</div>
			{% endfor %}
		</div>
		
		<a
			class="back-to-main"
			href="{{ url_for('calculator.view_candidates_responses') }}"
		><img
			src="{{ url_for('static', filename='images/back.svg') }}"
			width="25"
			height="25"
		>Zpět ke všem kandidátům</a>
	</main>
{% endblock %}

agreement/agreement/templates/candidates_responses.html
{% extends 'base.html' %}

{% block head %}
	<script
		src="{{ url_for('static', filename='js/select2.js') }}"
		type="text/javascript"
	></script>
	<script
		src="{{ url_for('static', filename='js/candidates_responses.js') }}"
		type="text/javascript"
	></script>
	
	<link
		rel="stylesheet"
		type="text/css"
		href="{{ url_for('static', filename='css/candidates_responses.css') }}"
	>
	<link
		rel="stylesheet"
		type="text/css"
		href="{{ url_for('static', filename='css/select2.css') }}"
	>
	
	<link
		rel="stylesheet"
		type="text/css"
		href="{{ url_for('static', filename='fonts/open-sans/style.css') }}"
	>
	<link
		rel="stylesheet"
		type="text/css"
		href="{{ url_for('static', filename='fonts/bebas-neue/style.css') }}"
	>
{% endblock %}

{% block current_page %}Shoda našich kandidátů{% endblock %}

{% block description %}Shoda našich kandidátů s našim programem.{% endblock %}

{% block content %}
	<header>
		<h1>Shoda našich kandidátů</h1>
	</header>
	
	<main>
		<form method="get" id="district-filter-form">
			<label
				for="obec"
			>Obec</label>
			
			<select name="obec" id="obec" autocomplete="off" style="width:200px">
				<option
					value="zadna"
					{% if selected_district_slug is none %}selected{% endif %}
				>Vybrat</option>
				
				{% for region in config["REGIONS"].values() %}
					<optgroup label="{{ region["name"] }}">
						{% for district_slug in region["districts"] %}
							<option
								value="{{ district_slug }}"
								{% if district_slug == selected_district_slug %}selected{% endif %}
							>{{ config["DISTRICTS"][district_slug]["name"] }}</option>
						{% endfor %}
					</optgroup>
				{% endfor %}
			</select>
			
			<noscript>
				<input
					type="submit"
					value="Filtrovat"
				>
			</noscript>
		</form>
		
		{% if selected_district_slug is not none %}
			<div class="people">
				{% for person_slug in cached_results["sorted_district_people"][selected_district_slug] %}
					{% set person = config["PEOPLE"][person_slug] %}
					<section class="person">
						<div class="person-image">
							<img
								src="{{ url_for('static', filename='images/people/' + person_slug + '.png') }}"
								alt="Fotka osoby {{ person["name"] }}"
							>
							
							<div class="person-agreement-percentage">
								<div
									class="person-agreement-percentage-bar"
									style="width:{{ cached_results["people"][person_slug]["percentage"] }}%;animation-delay:-{{ cached_results["people"][person_slug]["percentage"] / 100 }}s"
								>
									<span
										class="person-agreement-percentage-number"
									>Shoda {{ cached_results["people"][person_slug]["percentage"] }}%</span>
								</div>
							</div>
						</div>
						
						<div class="person-description">
							<h2>{{ person["name"] }}</h2>
							
							<tt style="background:grey;color:white;padding:5px">Sem patří popis kandidáta, odkazy, atd.</tt>
							
							<br>
							
							<a
								class="show-answers"
								href="{{ url_for('calculator.view_candidate_opinions', person_slug=person_slug) }}"
							><img
								src="{{ url_for('static', filename='images/mag.svg') }}"
								width="25"
								height="25"
							>Zobrazit odpovědi</a>
						</div>
					</section>
				{% endfor %}
			</div>
		{% endif %}
		
		<a
			class="back-to-main"
			href="/"
		><img
			src="{{ url_for('static', filename='images/back.svg') }}"
			width="25"
			height="25"
		>Zpět na hlavní stránku</a>
	</main>
{% endblock %}

agreement/agreement/templates/index.html
{% extends 'base.html' %}

{% block head %}
	<script
		src="{{ url_for('static', filename='js/index.js') }}"
		type="text/javascript"
	></script>
	
	<link
		rel="stylesheet"
		type="text/css"
		href="{{ url_for('static', filename='css/index.css') }}"
	>
	<link
		rel="stylesheet"
		type="text/css"
		href="{{ url_for('static', filename='fonts/open-sans/style.css') }}"
	>
	<link
		rel="stylesheet"
		type="text/css"
		href="{{ url_for('static', filename='fonts/bebas-neue/style.css') }}"
	>
{% endblock %}

{% block current_page %}Kalkulačka shody s Pirátským programem{% endblock %}

{% block description %}Zjisti, jakou máš shodu s naším programem!{% endblock %}

{% block content %}
	<header id="intro">
		<img
			id="header-logo"
			src="{{ url_for('static', filename='images/logo.png') }}"
			width="200"
			alt="Pirátské logo"
		>
		
		<div class="heading-container">
			<h1 class="heading">
				Zjisti, jakou máš shodu<br>
				s naším programem!
			</h1>
			
			<p class="description">
				<tt style="background:grey;color:white;padding:5px">Popis patří sem.</tt>
			</p>
			
			<a
				href="#test"
				class="jump-to-test"
			>Začni test&nbsp;&nbsp;→</a>
			
			<br>
			
			<a
				class="show-categories"
				href="{{ url_for('calculator.view_candidates_responses') }}"
			>Nebo se podívej na odpovědi našich kandidátů.</a>
		</div>
	</header>
	
	<main>
		<div class="content-container">
			<noscript>
				<p>
					Bohužel, verzi pro uživatele bez JavaScriptu jsem zatím nestihl udělat.<br>
					Naprosto respektuju tvoji volbu ho nepoužívat, a souhlasím s ní, ale...
					no, asi ti můžu rovnou říct, že - minimálně mezinárodní - Pirát jsi. :)
				</p>
			</noscript>
			
			<section id="test">
				<form
					method="POST"
					action="{{ url_for('calculator.view_result') }}"
					id="agreement-form"
				>
					{% for slug, question in config["QUESTIONS"].items() %}
						<h2>{{ question["content"] }}</h2>
						
						<div class="question-answers">
							<div class="question-answer question-answer-pos-full">
								<input
									type="checkbox"
									id="{{ slug }}-pos-full"
									name="{{ slug }}-pos-full"
									autocomplete="off"
								>
								
								<label
									id="{{ slug }}-pos-full-label"
									for="{{ slug }}-pos-full"
								></label>
							</div>
							
							<div class="question-answer question-answer-pos-half">
								<input
									type="checkbox"
									id="{{ slug }}-pos-half"
									name="{{ slug }}-pos-half"
									autocomplete="off"
								>
								
								<label
									id="{{ slug }}-pos-half-label"
									for="{{ slug }}-pos-half"
								></label>
							</div>
							
							<div class="question-answer question-answer-neut">
								<input
									type="checkbox"
									id="{{ slug }}-neut"
									name="{{ slug }}-neut"
									autocomplete="off"
									checked
								>
								
								<label
									id="{{ slug }}-neut-label"
									for="{{ slug }}-neut"
								></label>
							</div>
							
							<div class="question-answer question-answer-neg-half">
								<input
									type="checkbox"
									id="{{ slug }}-neg-half"
									name="{{ slug }}-neg-half"
									autocomplete="off"
								>
								
								<label
									id="{{ slug }}-neg-half-label"
									for="{{ slug }}-neg-half"
								></label>
							</div>
							
							<div class="question-answer question-answer-neg-full">
								<input
									type="checkbox"
									id="{{ slug }}-neg-full"
									name="{{ slug }}-neg-full"
									autocomplete="off"
								>
								
								<label
									id="{{ slug }}-neg-full-label"
									for="{{ slug }}-neg-full"
								></label>
							</div>
						</div>
						
						<script type="text/javascript">
							$(
								`#{{ slug }}-pos-full-label,
								#{{ slug }}-pos-half-label,
								#{{ slug }}-neut-label,
								#{{ slug }}-neg-half-label,
								#{{ slug }}-neg-full-label`
							).on(
								"click",
								function(event) {
									const inputId = event.currentTarget.id.replace("-label", "");
									const input = $("#" + inputId);
									
									if (input.prop("checked")) { // Always have one option selected
										event.preventDefault();
										return;
									}
									
									$(input[0].parentNode.parentNode)
									.children()
									.children("input").not(input)
									.prop("checked", false);
								}
							);
						</script>
					{% endfor %}
					
					<input
						type="submit"
						value="Zjistit výsledek!"
					>
				</form>
			</section>
		</div>
	</main>
	
	<footer>
		<p>
			K průzkumu ukládáme informace o tom, pro jaké otázky se jak hlasuje.<br>
			Osobní informace, včetně IP adres a všech dalších identifikátorů, ne.
		</p>
		<a href="#TODO">Jak počítáme výsledky?</a>
	</footer>
{% endblock %}

agreement/agreement/templates/result.html
{% extends 'base.html' %}

{% block head %}
	<script
		src="{{ url_for('static', filename='js/result.js') }}"
		type="text/javascript"
	></script>
	<script
		src="{{ url_for('static', filename='js/select2.js') }}"
		type="text/javascript"
	></script>
	
	<link
		rel="stylesheet"
		type="text/css"
		href="{{ url_for('static', filename='css/result.css') }}"
	>
	
	<link
		rel="stylesheet"
		type="text/css"
		href="{{ url_for('static', filename='css/select2.css') }}"
	>
	<link
		rel="stylesheet"
		type="text/css"
		href="{{ url_for('static', filename='fonts/open-sans/style.css') }}"
	>
	<link
		rel="stylesheet"
		type="text/css"
		href="{{ url_for('static', filename='fonts/bebas-neue/style.css') }}"
	>
{% endblock %}

{% block current_page %}Výsledek{% endblock %}

{% if percentage == 0 %}
	{% set heading = "Nula procent?!" %}
	{% set description = "Buď s námi opravdu hodně nesouhlasíš,<br>nebo jsi schválně na všechno dal zásadní nesouhlas. :(" %}
{% elif percentage < 35 %}
	{% set heading = "Bohužel, máš shodu jen {}%." %}
	{% set description = "Buď s námi prostě nesouhlasíš - na což máš plné právo - nebo máme otázky,<br>se kterými někteří Piráti nesouhlasí. Chceš nám o nich <a href=\"https://forum.pirati.cz\">napsat</a>?" %}
{% elif percentage < 55 %}
	{% set heading = "Máš slušnou shodu {}%!" %}
	{% set description = "Na některých věcech se možná neshodneme, ale na některých zase ano. :)" %}
{% elif percentage < 77 %}
	{% set heading = "Máš shodu {}%!" %}
	{% set description = "Je spousta věcí, na kterých se shodneme." %}
{% elif percentage <= 99 %}
	{% set heading = "Máš úžasnou shodu {}%!" %}
	{% set description = "Shodneme se prakticky na všem." %}
{% else %}
	{% set heading = "Máš úžasnou shodu {}%!!" %}
	{% set description = "Shodneme se úplně na všem." %}
{% endif %}

{% block description %}{% endblock %}

{% block content %}
	<header>
		<h1>{{ heading.format(percentage) }}</h1>
		<p>{{ description|safe }}</p>
	</header>
	<main>
		{% if percentage > 35 %}
			<h2>
				Kandidáti, kteří ti nejvíc sednou
			</h2>
			
			<form method="get" id="district-filter-form">
				<label
					for="obec"
				>Filtrovat podle obce</label>
				
				<select name="obec" id="obec" autocomplete="off" style="width:200px">
					<option
						value="zadna"
						{% if selected_district_slug is none %}selected{% endif %}
					>Vybrat</option>
					
					{% for region in config["REGIONS"].values() %}
						<optgroup label="{{ region["name"] }}">
							{% for district_slug in region["districts"] %}
								<option
									value="{{ district_slug }}"
									{% if district_slug == selected_district_slug %}selected{% endif %}
								>{{ config["DISTRICTS"][district_slug]["name"] }}</option>
							{% endfor %}
						</optgroup>
					{% endfor %}
				</select>
				
				<noscript>
					<input
						type="submit"
						value="Filtrovat"
					>
				</noscript>
			</form>
			
			{% if selected_district_slug is not none %}
				<div class="people">
					{% for candidate_slug, candidate in closest_candidates.items() %}
						{% set person = config["PEOPLE"][candidate_slug] %}
						<section class="person">
							<div class="person-image">
								<img
									src="{{ url_for('static', filename='images/people/' + candidate_slug + '.png') }}"
									alt="Fotka osoby {{ person["name"] }}"
								>
								
								<div class="person-agreement-percentage">
									<div
										class="person-agreement-percentage-bar"
										style="width:{{ candidate["percentage"] }}%;animation-delay:-{{ candidate["percentage"] / 100 }}s"
									>
										<span
											class="person-agreement-percentage-number"
										>Shoda {{ candidate["percentage"] }}%</span>
									</div>
								</div>
							</div>
							
							<div class="person-description">
								<h2>{{ person["name"] }}</h2>
								
								<tt style="background:grey;color:white;padding:5px">Sem patří popis kandidáta, odkazy, atd.</tt>
								
								<br>
								
								<a
									class="show-answers"
									href="{{ url_for('calculator.view_candidate_opinions', person_slug=candidate_slug) }}"
								><img
									src="{{ url_for('static', filename='images/mag.svg') }}"
									width="25"
									height="25"
								>Zobrazit odpovědi</a>
							</div>
						</section>
					{% endfor %}
				</div>
			{% endif %}
			
			<a
				class="back-to-main"
				href="{{ url_for('calculator.view_index') }}"
			><img
				src="{{ url_for('static', filename='images/reload.svg') }}"
				width="25"
				height="25"
			>Vyzkoušet test znovu</a>
		{% else %}
			<div style="padding-top:25px;text-align:center">
				<a
					class="back-to-main"
					href="{{ url_for('calculator.view_index') }}"
				><img
					src="{{ url_for('static', filename='images/reload.svg') }}"
					width="25"
					height="25"
				>Vyzkoušet test znovu</a>
			</div>
		{% endif %}
		
	</main>
{% endblock %}